//<

void populateConf(string filename)
{
		       		
	DOM_Document_ d=xmlParseFile(filename)
	if (! null d)
    {
		// ... get the root element
       	DOM_Element_ de = getDocumentElement_(d)
       	string rt = getElementName_(de)

       	if(rt=="source")
       	{
	       		DOM_Element_ tmplElem
	       		int index=0
	       		for tmplElem in de do
	       		{
		       		string tmplElemName = getElementName_(tmplElem)
		       		if(tmplElemName == "output_file")
		       		{
			       		xmlFileName = getElementText_(tmplElem)
			       		//put(dsSkip,"output_file",getElementText_(tmplElem))
			       	}
			       	else if(tmplElemName == "err_file")
			       	{
				       	errFileName = getElementText_(tmplElem)
				       	//put(dsSkip,"err_file",getElementText_(tmplElem))
				    }
				    else if(tmplElemName == "log_file")
				    {
					    logFileName = getElementText_(tmplElem)
					   	//put(dsSkip,"log_file",getElementText_(tmplElem))
					}
					else if(tmplElemName == "abort_file")
					{
						abortFileName = getElementText_(tmplElem)
						//put(dsSkip,"abort_file",getElementText_(tmplElem))
					}
					else if(tmplElemName == "work_dir")
					{
						strWorkDir = getElementText_(tmplElem)
					}
			}	
	    }
  	}
  	
}

void parseItem(Item i)
{
	Item it
	string itempath= fullName(i)
	
	for it in folder(itempath) do
	{
		
		if( type(it) == "Folder" || type(it) == "Project" )
		{
			xmlWriteStartElement(XML_FOLDER)
			if(type(it) == "Folder")
			{
				xmlWriteAttributeString( "isProject", "false")
			}
			else
			{
				xmlWriteAttributeString( "isProject", "true")
			}
			
			
			xmlWriteAttributeString( XML_NAME, name(it))
			xmlWriteAttributeString( XML_ID, uniqueID(it))
			xmlWriteAttributeString( XML_DESCRIPTION, description(it))
			xmlWriteAttributeString( XML_URL, getURL(it))
				
			parseItem(it)
			
			xmlWriteEndElement(true)
		}
		else
		{
			if(type(it) == "Formal")
			{
				xmlWriteStartElement(XML_MODULE)//<attribute>
				xmlWriteAttributeString( XML_NAME, name(it))
				xmlWriteAttributeString( XML_FULL_NAME, fullName(it))
				xmlWriteAttributeString( XML_ID, uniqueID(it))
				xmlWriteAttributeString( XML_DESCRIPTION, description(it))
				xmlWriteAttributeString( XML_URL, getURL(it))
				xmlWriteAttributeString( XML_TYPE, "Formal")
				xmlWriteEndElement(true)	
			}
			else
			{
				if(type(it)== "Link")
				{
					xmlWriteStartElement(XML_MODULE)//<attribute>
					xmlWriteAttributeString( XML_NAME, name(it))
					xmlWriteAttributeString( XML_FULL_NAME, fullName(it))
					xmlWriteAttributeString( XML_ID, uniqueID(it))
					xmlWriteAttributeString( XML_DESCRIPTION, description(it))
					xmlWriteAttributeString( XML_URL, getURL(it))
					xmlWriteAttributeString( XML_TYPE, "Link")
					xmlWriteEndElement(true)	
				}
				else
				if(type(it)=="Descriptive")
				{
					xmlWriteStartElement(XML_MODULE)//<attribute>
					xmlWriteAttributeString( XML_NAME, name(it))
					xmlWriteAttributeString( XML_FULL_NAME, fullName(it))
					xmlWriteAttributeString( XML_ID, uniqueID(it))
					xmlWriteAttributeString( XML_DESCRIPTION, description(it))
					xmlWriteAttributeString( XML_URL, getURL(it))
					xmlWriteAttributeString( XML_TYPE, "Descriptive")
					xmlWriteEndElement(true)
				}
			}
		}
	}
}


void writeDSStructure()
{
	xmlWriteStartElement(XML_DATABASE)//<attribute>
	xmlWriteAttributeString( XML_NAME, getDatabaseName())	
	xmlWriteAttributeString( XML_ID, getDatabaseIdentifier())	
	current = folder "/"
	Item i
	for i in current Folder do
	{
		
		if( type(i) == "Folder" || type(i) == "Project" )
		{
			xmlWriteStartElement(XML_FOLDER)//<attribute>
			if(type(i) == "Folder")
			{
				xmlWriteAttributeString( "isProject", "false")
			}
			else
			{
				xmlWriteAttributeString( "isProject", "true")
			}
			
			xmlWriteAttributeString( XML_NAME, name(i))
			xmlWriteAttributeString( XML_ID, uniqueID(i))
			xmlWriteAttributeString( XML_DESCRIPTION, description(i))
			xmlWriteAttributeString( XML_URL, getURL(i))
				
			parseItem(i)
			
			xmlWriteEndElement(true)	
		}
		
		
	}

	xmlWriteEndElement(true)//end database
	
	
}
string filename=getDXLArgument()
if(canOpenFile(filename,false))
{
	populateConf(filename)

	xmlInitStream(xmlFileName)
	
	// ... open the root element
	xmlWriteStartDocument()
	
	writeDSStructure()
	//solveQuery( strModPath, strModId, strBaselineName, strViewName, skpTokens)
	
	// ... close the xml stream
	xmlCloseStream()

}
else
{
	ack "Cannot open: " filename "\n"
}
