VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} ProfileConvert 
   Caption         =   "ProfileConvert"
   ClientHeight    =   3225
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4710
   OleObjectBlob   =   "ProfileConvert.frx":0000
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "ProfileConvert"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub pConvert_Click()

    Dim prj As RPProject
    Dim profile As RPProfile
    Dim stereotype As RPStereotype

    On Error GoTo error
    
    Set prj = getProject
    
    Set profile = prj.findNestedElementRecursive("SPT", "Profile")
    
    Dim stCol As RPCollection
    
    Dim e As RPModelElement
    
    Set stCol = profile.getNestedElementsRecursive
    For Each e In stCol
        If e.metaClass = "Stereotype" Then
            Set stereotype = e
            
            Dim oPrp As RPCollection
            
            Set oPrp = stereotype.getOverriddenProperties(0)
            Dim prpStr As String
            Dim i As Integer
            For i = 1 To oPrp.Count
                prpStr = oPrp.Item(i)
                Dim dotP As Integer
                Dim colP As Integer
                Dim tagName As String
                Dim tag As RPTag
                
                dotP = InStrRev(prpStr, ".")
                colP = InStrRev(prpStr, ":")
                tagName = Mid(prpStr, dotP + 1, colP - dotP - 1)
                
                Set tag = stereotype.addNewAggr("Tag", tagName)
                
            Next i
            
        End If
    Next e
done:

Exit Sub

error:
    MsgBox errorMessage

End Sub
