/* Licensed Materials - Property of IBM */
/* (c) Copyright IBM Corporation 2009. All Rights Reserved. */

#ifndef rtwtypes_H
#define rtwtypes_H

//don't use this type incase the 'tmwtypes_h' is defined (like happens with S_Function)
#ifndef tmwtypes_h
/*## package rtwtypes */


/*## type boolean_T */
typedef unsigned char boolean_T;

/*## type char_T */
typedef char char_T;

/*## type byte_T */
typedef char_T byte_T;

/*## type int_T */
typedef int int_T;

/*## type DTypeId */
typedef int_T DTypeId;

/*## type int16_T */
typedef short int16_T;

/*## type int32_T */
typedef int int32_T;

/*#[ type int8_T */
typedef signed char int8_T;
/*#]*/

/* Block D-Work pointer type  */
/*## type pointer_T */
typedef void * pointer_T;

/*## type real_T */
typedef double real_T;

/*## type real32_T */
typedef  double real32_T;

/*## type real64_T */
typedef double real64_T;

/*## type time_T */
typedef double time_T;

/*## type uint_T */
typedef  unsigned int uint_T;

/*## type uint16_T */
typedef unsigned short uint16_T;

/*## type uint32_T */
typedef  unsigned int uint32_T;

/*## type uint8_T */
typedef unsigned char uint8_T;

/*## type UnknownType */
typedef void * UnknownType;

#endif //tmwtypes_h
#endif //rtwtypes_H
